/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*1.9*19/04/93*ITSlite preprocessor commands "CSCAPEVER=1"       *30301*MW */
/***************************************************************************/
/*1.8*01/07/92*Adjusted colours for screens.                     *30301*MJH*/
/***************************************************************************/
/*1.7*01/06/92*Moon Translation repurcussions for translation.   *30301*MJH*/
/***************************************************************************/
/*1.6*29/05/92*Standardised function naming & calling convention.*30301*MJH*/
/***************************************************************************/
/*1.5*13/05/92*Released for use in ITS Ver 1.0                   *30301*KJM*/
/***************************************************************************/
/*1.4*07/05/92*Braille line nos core file name defined.          *30301*MJH*/
/***************************************************************************/
/*1.3*01/05/92*Added MAXBANNERKEYWORDLENGTH #define line.        *30301*KJM*/
/***************************************************************************/
/*1.2*28/04/92*Incorporated PG_RANGE.H into this source file     *30301*KJM*/
/***************************************************************************/
/*1.1*31/03/92*Integration into ITS 									  *30301*MJH*/
/***************************************************************************/
/*1.0*18/02/92*Creation Date                                     *30301*KJM*/
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/*BRLEMBOP.C ITSMENU.C ITBEMBOP.C ITSFUNC.C	  		           */
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/

/* Header file for the OUTPUT phase of RNIB's ITS */
#define ERROR 0
#define NOERROR 1
#define TRUE 1
#define FALSE 0
#define SUCCESS 0
#define FAILURE 1
#define NOLINENUMBERS FALSE
#define CLOSEOK 0
#define STARTSEQ 0
#define ENDSEQ 1
#define CNTRL_Z '\x1A'
#define ESCAPE 27
#define FORMFEED "\x0C"
#define FIRSTLINE 1

#define BRLLINENUMCORENAME "BRLLINE.NOS"

#define MAXBRLLINENOS 30
#define MAXBRLLINENOLENGTH 3 /* Including the terminating NULL */
#define MAXEXPANDEDKEYWORDLENGTH 80
#define MAXBANNERPAGESIZE 1024u /* Allow for 25 lines X 40 columns */
#define MAXBANNERKEYWORDLENGTH 25
#define MAXOUTPUTLINELENGTH 256
#define MAXPATHLENGTH 70
#define MAXDRIVELENGTH 3
#define MAXFNAMELENGTH 10
#define MAXEXTLENGTH 5

/* defined constants for screen */
#define OUTBOXWIDTH 60
#define OUTBOXHEIGHT 12
#define OUTBOXROWPOS 10
#define OUTBOXCOLPOS 10
#define OUTBOXREGCLR 0x3f
#define OUTBOXHICLR 0x4f
#define OUTBOXBACKCLR 0x3f
#define OUTBOXPROMPTCLR 0x3f

#define VALID TRUE /* OK, ok so I could have just used TRUE and FALSE, */
#define INVALID FALSE /* but it doesn't take up any run-time processor time...*/
#define NOTINRANGE 0
#define INRANGE 1
#define ENDOFRANGE 2

#ifdef CSCAPEVER
extern const char *PAGERANGEALL;
#endif
#define ABS_FIRST_PAGE 1
#define ABS_LAST_PAGE 32767

#ifdef CSCAPEVER
char PromptTemp[255];
menu_type process_menu;
sed_type process_sed;
#endif


struct BRLLineNumberType {
     char BRLLineNo[MAXBRLLINENOLENGTH];
};

#ifdef CSCAPEVER
extern struct PageRangeNode *PageRange;

 /*Pre-declared page range - All pages selected */
extern struct PageRangeNode ALLPageRange;
#endif

/***************************************************************************/
void FreePageRangeNodes(struct PageRangeNode *Node);
char ValidPageRange(char *PageRangeStr);
char BuildPageRange(char *PageRangeStr);
char CheckPageRange(struct PageRangeNode *PageRanges, unsigned int CurrentPage);
/* REMOVED - now in ITSFUNC.H char *charncpy(char *dest, const char *src, const size_t maxlen);*/
void BRLEmbOut(/* Translate Parameter(s) */
	     int Grade,
	     boolean *TranslateInitFlag,
        boolean *MoonInit,
	     char *BRLTranslatedFilename,
	    /* Format Parameter(s) */
	     char *FCTabFilename, char *CWTFilename, char *ReportFilename,
	     size_t PageWidth, size_t PageLength, size_t StartPageNo,
	     int HeaderType,
	     boolean HeaderFlag,
	    /* Output Parameters - at last! */
	    char *AbsSourceFilename,
	    char *LeadingBannerPageFilename,
	    char *TrailingBannerPageFilename,
	    char *StartSeqFilename,
	    char *EndSeqFilename,
	    char *OutputDest,
	    boolean LineNumbersRequired,
	    boolean FontSendRequired,
	    char *FontDataFilename,
	    unsigned int NoOfCopies,
	    struct PageRangeNode *PageRanges,
	    boolean Network,
	    char *BRLFilename,
	    /* System type parameters */
	    boolean SystemPause,
	    boolean ScreenOn);

