/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/* ITPF.H  ITS large print format header file */
/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*1.5*23/04/93*C_RESOLUTION added; new IT_setmargin prototype.   *30404*NO */
/***************************************************************************/
/*1.4*01/07/92*Colours adjusted for processing screen            *30301*MJH*/
/***************************************************************************/
/*1.3*04/06/92*Standardised function naming and calling.         *30301*MJH*/
/***************************************************************************/
/*1.2*28/05/92*References to _FAR_ removed.                      *30301*MJH*/
/***************************************************************************/
/*1.1*18/05/92*Version Notes added.                              *30301*KJM*/
/***************************************************************************/
/*1.0*??/11/91*Creation Date.                                    *30301*NO */
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/* ITSAUTO.C ITSMENU.C ITBEMBFM.C BFFUNCS.C BRLEMBOP.C                     */
/*                                                                         */
/* ISFC.C ITBCENTR.C ITBEMBFM.C ITBFERR.C ITBPAD.C ITBRJUST.C ITEOP.C      */
/* ITFCPARS.C ITFMEXEC.C ITGTWORD.C ITMFILL.C ITMKPG.C ITOBRL.C ITOBROM.C  */
/* ITPGHDR.C ITRDBFRM.C ITRDCWT.C ITREPORT.C ITSETPGN.C ITSETPPG.C         */
/* ITSPLWRD.C ITWRITPG.C STORLINE.C TEXTLEN.C                              */
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>

/* Manifest constants
   ------------------ */
/* Format code constants */
#define ITFCSTART 0x01
#define ITFCstart "\x1" /* String constant */
#define MAXFCFIELDS 6
/* Character widths */
#define CWU 1440u /* Proportional fonts - twips */
#define CVTOCWU 30 /* Convert from 1/10 inch to DPI */
#define MINSPACEWIDTH (CWU/20)+1 /* hopefully a sensible minimum char width! *//*TEST*/
#define FONTSIZE 19
/*   The following macro refers to the char width array cwt (see IT_readCWT) */
/*test#define cw(c) (unsigned)((cwt[(c)]) * FONTSIZE / 50u)*/
/* PCL commands */
#define HM_CMND_START "\x1b*p"      /* Horizontal motion */
#define HM_CMND_END "X"
#define RELATIVE_FORWD "+"
#define RELATIVE_BACKWD "-"
/* Format Code table */
#define MAXFC 0x100
/* Characters */
#define EOFCHAR 0x1A
#define ESCKEY 0x1B
#define PSLINE_END ") show\n" /*test150793*/
/* Dimensions */
#define MAXA4WIDTH_PCLRES (int)(117L*CWU/10)
/*test#define MAXLINELEN (MAXA4WIDTH_PCLRES/MINSPACEWIDTH) * Related to max. wide-carriage printer line-length */
#define MAXLINELEN A4PWIDTH_TWIP * 2 / min_non0width /*test*/
#define MAXPAGELEN 70 /* Related to portrait A4 paper size  */
#define A4PWIDTH_TWIP 11909u
#define A4PLENGTH_TWIP 16834u
#define MAX_PRN_INSTRUCT_LENGTH 15
#define CV_10THINCHTOCWU 30
/* Flags for sysparam struct */
#define IT_REPORT	1
#define IT_HDR_REFLECT	2
/* Flags for txtline.attrib */
#define NORMAL		0L
#define CENTRE		1L
#define RJUST		2L
#define P_HEADER	4L
#define T_HEADER	8L
#define FOOTER		0x10L
#define BLOCK		0x20L
#define TABMODE		0x40L
#define BLANK		0x80L
#define NEWTITLE	0x100L
#define P_HEADER_OVRWRT 0x200 /*test*/
/* System flags */
#define ABORT           !0
/* Values for pg_settings.paginat_ind */
#define ARABIC  	0
#define ROMAN		1

/* screen */
#define FORMBOXWIDTH 60
#define FORMBOXHEIGHT 10
#define FORMBOXROWPOS 10
#define FORMBOXCOLPOS 10
#define FORMBOXREGCLR 0x3f
#define FORMBOXHICLR 0x4f
#define FORMBOXBACKCLR 0x3f
#define FORMBOXPROMPTCLR 0x3f

/* types
  ----- */

/* Externals
   --------- */
/* Structures */
#if !defined(_FC_DEFINED)
struct IT_FCode {
  char *in;
  char *out; /* symbolic constants: s = string; c = char; n = number */
  int r1; /* bottom of range */
  int r2; /* top of range */
  char reduceto; /* r2 set: p = pagelen; l = linelen; m = maximum (0xFFFF) */
  int dflt; /* Default */
};
struct FCparam {
  int npar1;
  int npar2;
  char spar[20];
};
struct pg_settings {
  size_t pagecount;
  size_t linecount;
  size_t storecount;
  unsigned long abslinecount;
  size_t blanklines;
  size_t abslinelength;
  size_t lptr; /* Records position from beginning of line */
  int lmarg, rmarg;
  char pp[20], oldpp[20];
  size_t blocksize;
  int paginat_ind;
  int header_ind;
  flag no_pg_breaks;
};
struct txtline {
  char text[128];
  unsigned long attribs;
};
#define _FC_DEFINED
#endif
#if !defined(_TAB_DEFINED)
struct tab {
  char type;
  char filler;
  size_t pos;
};
#define _TAB_DEFINED
#endif
extern struct IT_FCode  **BFC;
extern struct tab tabs[];

extern int *cwt, min_non0width, max_non0width;
extern const char space;
extern const char *space_str;
extern const char SYS_NAME[];
extern boolean abrt;
extern int topmargin, bottommargin;
extern int lmargin, rmargin, y_inc; /* Defined in LPSUPORT.C */


/* Function prototypes
   ------------------- */
size_t           cw            (int c);
char             *IToBrl       (int num);
char		     *IStrToBrl	   (char  *numstr);
char		     *IToRom	   (int n, int mode);
char		     *IToBRom	   (int n);
FILE		    *IT_fopen		   (char  *filename,
					   char  *mode);
int		    IT_fclose		   (FILE *stream);
int		    *IT_readcwt		   (char  *cwtfname,
                       int  *cwt,
                       int *min_non0width, int *max_non0width);
char		     *IT_BEmbCentre   (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_PCLCentre   (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_PscCentre   (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_BEmbRjust     (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_PCLRjust      (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_PscRjust      (char  *text, size_t maxlen,
					   size_t startpos, int  *cwt);
char             *IT_BEmbPad       (char  *Text,
					   size_t length,
					   int  *cwt);
int		    TextLength		   (char  *Text, int  *CWT);
char *make_prn_seq_str(char *beginning, int num, char *end);
int __cdecl      IT_error           (char  *modulename,
					   char  *fmt, ...);
struct IT_FCode	     **IT_GetBFormatCodes   (char  *FCfname,
					   struct IT_FCode  *FC[],
					   size_t linelen, size_t pagelen);
int         MoonPscForm(char  *infilename,
					   char  *outfilename,
					   char  *fctabname,
					   char  *cwtname,
					   char  *reportfilename,
                       int lmargin, int rmargin, size_t lineheight,
					   size_t startpage, int header_ind,
						flag header_ref, flag reportflag,
						boolean ScreenOn,
						boolean SysPause);
char		     *IT_getword	   (FILE *infile, char inbuffer[],
					   char Wbuffer[], char FCbuffer[],
					   struct FCparam  *FCpar,
					   struct IT_FCode  **FC,
					   flag  *EndOfText);
char		     *nxtword	   (char  **bufptr,
					   int  *bufleft);
char		     *IT_readin	   (FILE *infile, char  *inbuffer,
					   char  *bufptr,
					   int  *bufleft);
struct IT_FCode	     *isFC	   	   (char  *instr,
					   char  *FCbuffer,
					   struct IT_FCode  **FCtable);
struct FCparam	     *IT_getFCparams  (char  *FCstring,
					   struct FCparam  *params,
					   char  *FCcore,
					   struct IT_FCode  *FCentry);
char             *IT_splitlpword (char  *word,
					   char  *w2buf,
                       size_t cwucount, int *cwt);
size_t      CalcCW             (char *s, int n, int *cwt);
int         IT_settab          (size_t tabnumber, char tabtype,
					   size_t tabpos, struct tab tabset[],
                       size_t linelength);
int		    IT_setmargin	   (int mvalue, int  *mbuf,
                       int maxlen, int *cwt);
int		    IT_setpageno	   (int pnvalue, unsigned  *pnbuf,
					   size_t maxlen);
char		     *IT_set_ppstr	   (char  *ppstr, char  *buf,
					   size_t maxlen);
void __cdecl     IT_report          (char  *fmt, ...);
char             *IT_lptabjump           (size_t tabnumber,
					   struct tab tabs[], char  *line,
					   size_t  *lpos, size_t llength,
					   char  *nextword,
					   int  *cwt);
char		     *IT_mkfiller	   (char filler, size_t n,
					   char  *line,
					   size_t  *lpos, size_t llength,
					   int  *cwt);
int          IT_MPsc_formatexec      (FILE *source, FILE *dest,
                       char *infilename, char *outfilename,
                       int lmargin, int rmargin, size_t lineheight,
					   size_t startpage, int header_ind,
					   flag header_ref,
					   struct IT_FCode  **FCtable,
						int  *cwt,
						boolean ScreenOn, boolean SysPause);
flag			 ITF_cnfirmabrt		(char  *promptstr,
					   int  *abrt);
void __cdecl     ctrlchandler       (int sig);
struct txtline       *IT_pscline      (size_t linelength, size_t pagelength,
					   struct pg_settings  *p,
					   int  *cwt,
					   struct IT_FCode  **BFC,
					   FILE *source,
					   unsigned long  *modeflags,
					   flag  *forcedpage,
					   flag  *EndOfText);
flag		    IT_confirmabrt	   (char  *promptstr,
						boolean  *abrt);
int __cdecl      IT_print           (const char  *fmt, ...);
void		    IT_prompt		   (char  *promptstr);
int		    IT_confirmpage	   (struct txtline line[],
					   unsigned long  *modeflags,
					   size_t pagesize,
					   size_t  *linecount,
					   size_t pagecount);
struct txtline	     *IT_storeline	   (struct txtline line[],
					   struct txtline  *linep,
					   size_t  *linecount,
					   size_t  *storecount,
					   unsigned long *abslinecount);
int         IT_mk_MPsc_page          (struct txtline line[],
					   char  *header,
					   char  *printpagestr,
					   int paginat_ind, int header_ind,
					   flag no_pg_breaks,
					   size_t  *pagecount,
					   size_t  *linecount,
					   size_t  *storecount,
                       size_t linelength, int *cwt,
					   FILE *dest);
int mk_MPsc_pagehdr(char *header, char *printpagestr, size_t pagecount,
    int paginat_ind, size_t length, int *cwt);
    /* Prototype */
int         writepspage        (struct txtline line[],
					   char  *header, size_t linecount,
					   size_t pagecount, flag no_pg_breaks,
					   FILE *dest);
