/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/* Start of ITS.H */
/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*2.0*13/10/93*BRAILLE_IT compiler directive now comments out    *30409*KJM*/
/*   *        *code not specifically needed in 'ItsLite'.        *     *   */
/***************************************************************************/
/*1.8*21/07/93*Moon config. menu amended.                        *30406*MJH*/
/***************************************************************************/
/*1.7*15/07/93*Moon Outputting menu option added.                *30406*MJH*/
/***************************************************************************/
/*1.6*08/06/93*Moon PCL formatting added.                        *30105*NO */
/***************************************************************************/
/*1.5*19/04/93*ITSlite preprocessor commands "CSCAPEVER=1"       *30301*MW */
/***************************************************************************/
/*1.4*29/05/92*Moon translation added.                           *30301*MJH*/
/***************************************************************************/
/*1.3*26/05/92*Anticipatory headings changed name.               *30301*MJH*/
/***************************************************************************/
/*1.2*20/05/92*Rationalised header files.                        *30301*MJH*/
/***************************************************************************/
/*1.1*18/05/92*Version Notes added.                              *30301*KJM*/
/***************************************************************************/
/*1.0*08/05/92*Creation Date.                                    *30301*MJH*/
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/* BFFUNCS.C BRLEMBOP.C ITBEMBOP.C ITBEMBFM.C ITTRANS.C ITS.C ITSAUTO.C    */
/* ITSFUNC.C ITSMENU.C TRANFILE.C  BRLEMBFM                                */
/*                                                                         */
/* ISFC.C ITBCENTR.C ITBFERR.C ITBPAD.C ITBRJUST.C ITEOP.C                 */
/* ITFCPARS.C ITFMEXEC.C ITGTWORD.C ITMFILL.C ITMKPG.C ITOBRL.C ITOBROM.C  */
/* ITPGHDR.C ITRDBFRM.C ITRDCWT.C ITREPORT.C ITSETPGN.C ITSETPPG.C         */
/* ITSPLWRD.C ITWRITPG.C STORLINE.C TEXTLEN.C                              */
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/

/* System include files */
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <conio.h>
#include <io.h>
#if !defined(BRAILLE_IT)
#include <graph.h>
#endif
#include <ctype.h>
#include <process.h>
#include <fcntl.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>
#include <dos.h>
#include <direct.h>
#include <errno.h>

#ifdef CSCAPEVER
/* C-scape include files */
#pragma warning(disable:4121)
#include <cscape.h>
#include <popdecl.h>
#include <framer.h>
#include <scancode.h>
#include <sfile.h>
#include <helpdecl.h>
#pragma warning(default:4121)
#else
typedef int boolean;
#endif


/* ------------------------- DEFINED CONSTANTS ---------------------------- */
                 
#ifndef TRUE
#define 	TRUE 	1
#endif
#ifndef FALSE
#define 	FALSE 	0
#endif

#if defined(BRAILLE_IT)
#define ERRMSGSIZE 128
#else
#define ERRMSGSIZE 480
#endif
#define ESCKEY 0x1B

#define MAXPARAMDESC 40
#define PARAMENTRYLENGTH 122    /* 40 description, space, 80 filename */
#define FILENAMELENGTH 81
#define ARRAY80LENGTH 81
#define MAXSEQUENCELENGTH 256
#define NAMELENGTH 9
#define EXTLENGTH 5
#define DRIVELENGTH 3
#define PORTLENGTH 5
#define NUMBER_STRLEN 7

#define EMPTYDEFAULT80  "\0"

#define SCREENFILENAME  "ITS.LNF"
#define HELPFILENAME    "ITS.HLP"

/* Colours */
#define BACK_CLR 0x11
#define FRAMELOCK_CLR 0x75

/* Automatic processing defaults */
#define DEFAULTAUTOREQUIRED                     FALSE
#define DEFAULTAUTOBRLREQUIRED          FALSE
#define DEFAULTAUTOBRLTRANS                     FALSE
#define DEFAULTAUTOBRLEMBFORM                   FALSE
#define DEFAULTAUTOBRLPCLFORM                   FALSE
#define DEFAULTAUTOBRLPSCFORM               	FALSE
#define DEFAULTAUTOMOONREQUIRED         FALSE
#define DEFAULTAUTOMOONTRANS                    FALSE
#define DEFAULTAUTOMOONPSCFORM                  FALSE
#define DEFAULTAUTOMOONPCLFORM                  FALSE
#define DEFAULTAUTOSCREENON                     TRUE

/* System Parameters */

#define DEFAULTCONFIGPARAMNAME  "ITSSYS.LST"
#define DEFAULTSOURCENAME       EMPTYDEFAULT80
#define DEFAULTPAGERANGE        EMPTYDEFAULT80
#define DEFAULTCOPIES           1

#define NUMBERCONFIGDECODEPARAM 9

#define SOURCEDIR                               "Source_Dir"
#define DEFAULTSOURCEDIR        EMPTYDEFAULT80
#define SOURCEEXT                               "Source_Ext"
#define DEFAULTSOURCEEXT        "TXT"

#define NETWORK                 "Network"
#define DEFAULTNETWORK  FALSE
#define CONFIRM                 "Confirm"
#define DEFAULTCONFIRM  TRUE
#define PAUSE                           "Pause"
#define DEFAULTPAUSE            FALSE

#define EMBOSSNAME                      "Emboss_Output_File"
#define DEFAULTEMBOSSNAME       EMPTYDEFAULT80
#define PCLNAME                      "PCL_Output_File"
#define DEFAULTPCLNAME       EMPTYDEFAULT80

#define EMBOSSPORT                      "Emboss_Port"
#define DEFAULTEMBOSSPORT       "FILE"
#define PCLPORT                         "PCL_Port"
#define DEFAULTPCLPORT          "FILE"

#define PSCNAME                         "PScript_Output_File"
#define DEFAULTPSCNAME EMPTYDEFAULT80
#define PSCPORT                     "PScript_Port"
#define DEFAULTPSCPORT           "FILE"


/* Braille Parameters */

#define DEFAULTBRLPARAMNAME             "ITSBRL.LST"
#define DEFAULTBRLTRANSINIT             FALSE
#define DEFAULTBRLTRANSNAME     EMPTYDEFAULT80
#define DEFAULTBRLEMBFORMNAME EMPTYDEFAULT80
/* The next parameter will be configurable when rep files are implemented */
#define DEFAULTBRLEMBREP                        "ITBRLEMB.REP"

#define NUMBERBRLDECODEPARAM 19

#define BRLTRANSDIR                             "Brl_Trans_Dir"
#define DEFAULTBRLTRANSDIR      EMPTYDEFAULT80
#define BRLTRANSEXT                             "Brl_Trans_Ext"
#define DEFAULTBRLTRANSEXT              "BRL"

#define BRLEMBFORMDIR                   "Brl_Emb_Form_Dir"
#define DEFAULTBRLEMBFORMDIR    EMPTYDEFAULT80
#define BRLEMBFORMEXT                   "Brl_Emb_Form_Ext"
#define DEFAULTBRLEMBFORMEXT    "EMB"

#define BRLEMBPAGEWIDTH                         "Brl_Emb_Page_Width"
#define DEFAULTBRLEMBPAGEWIDTH  (size_t) 40
#define BRLEMBPAGELENGTH                        "Brl_Emb_Page_Length"
#define DEFAULTBRLEMBPAGELENGTH (size_t) 0

#define BRLEMBFIRSTPAGE                         "Brl_Emb_First_Page_No"
#define DEFAULTBRLEMBFIRSTPAGE  (size_t) 1

#define BRLHEADERTYPE                   "Brl_Header_Type"
#define DEFAULTBRLHEADERTYPE    (int) 3

#define BRLHEADERREFLECT                        "Brl_Anticipatory_Headings"
#define DEFAULTBRLHEADERREFLECT TRUE

#define BRLTRANSTABLE                   "Brl_Trans_Table"
#define DEFAULTBRLTRANSTABLE    "ITSBRL.TAB"

#define BRLACRONYMTABLE         "Brl_Acronym_Table"
#define DEFAULTACRONYMTABLE     "ITBACRO.TAB"

#define BRLTRANSGRADE                           "Brl_Trans_Grade"
#define DEFAULTBRLTRANSGRADE                     2

#define BRLEMBFCODE                             "Brl_Emb_Format_Codes"
#define DEFAULTBRLEMBFCODE              "ITBEMBFC.TAB"

#define BRLEMBCWT                               "Brl_Emb_CWT"
#define DEFAULTBRLEMBCWT                        "ITBEMBCW.TAB"

#define BRLLINENOS                              "Brl_Line_Numbers"
#define DEFAULTBRLLINENOS               FALSE

#define BRLEMBSTARTBANNER                               "Brl_Emb_Start_Banner"
#define DEFAULTBRLEMBSTARTBANNER        EMPTYDEFAULT80

#define BRLEMBENDBANNER                         "Brl_Emb_End_Banner"
#define DEFAULTBRLEMBENDBANNER  EMPTYDEFAULT80

#define BRLEMBSTARTSEQ                          "Brl_Emb_Start_Sequence"
#define DEFAULTBRLEMBSTARTSEQ   EMPTYDEFAULT80

#define BRLEMBENDSEQ                                    "Brl_Emb_End_Sequence"
#define DEFAULTBRLEMBENDSEQ             EMPTYDEFAULT80

/* The following are not yet incorporated into config decode table */
/* But they are in the parameter store */
#define BRLPCLFORMDIR                   "Brl_PCL_Form_Dir"
#define DEFAULTBRLPCLFORMDIR    EMPTYDEFAULT80
#define BRLPCLFORMEXT                   "Brl_PCL_Form_Ext"
#define DEFAULTBRLPCLFORMEXT    "PCL"
#define DEFAULTBRLPCLFORMNAME EMPTYDEFAULT80

#define BRLPSCRIPTFORMDIR                               "Brl_PScript_Form_Dir"
#define DEFAULTBRLPSCRIPTFORMDIR        EMPTYDEFAULT80
#define BRLPSCRIPTFORMEXT                               "Brl_PScript_Form_Ext"
#define DEFAULTBRLPSCRIPTFORMEXT                "PSC"
#define DEFAULTBRLPSCRIPTFORMNAME       EMPTYDEFAULT80

/* Moon Parameters */

#define DEFAULTMOONPARAMNAME             "ITSMOON.LST"
#define DEFAULTMOONTRANSINIT             FALSE
#define DEFAULTMOONTRANSNAME     EMPTYDEFAULT80
#define DEFAULTMOONPCLFORMNAME EMPTYDEFAULT80
#define DEFAULTMOONPSCFORMNAME EMPTYDEFAULT80
/* The next parameterS will be configurable when rep files are implemented */
#define DEFAULTMOONPCLREP                        "ITMOOPCL.REP"
#define DEFAULTMOONPSCREP                        "ITMOOPSC.REP"

#define NUMBERMOONDECODEPARAM 22

#define MOONTRANSDIR                             "Moon_Trans_Dir"
#define DEFAULTMOONTRANSDIR      EMPTYDEFAULT80
#define MOONTRANSEXT                             "Moon_Trans_Ext"
#define DEFAULTMOONTRANSEXT              "MOO"

#define MOONPCLFORMDIR                   "Moon_PCL_Form_Dir"
#define DEFAULTMOONPCLFORMDIR    EMPTYDEFAULT80
#define MOONPCLFORMEXT                   "Moon_PCL_Form_Ext"
#define DEFAULTMOONPCLFORMEXT    "PCM"

#define MOONPSCFORMDIR                   "Moon_Psc_Form_Dir"
#define DEFAULTMOONPSCFORMDIR    EMPTYDEFAULT80
#define MOONPSCFORMEXT                   "Moon_Psc_Form_Ext"
#define DEFAULTMOONPSCFORMEXT            "PSM"

#define MOONPCLLMARGIN                           "Moon_PCL_Left_Margin"
#define DEFAULTMOONPCLLMARGIN "0.5"
#define MOONPCLRMARGIN                           "Moon_PCL_Right_Margin"
#define DEFAULTMOONPCLRMARGIN "0.5"
#define MOONPCLTOPMARGIN                           "Moon_PCL_Top_Margin"
#define DEFAULTMOONPCLTOPMARGIN "1.0"
#define MOONPCLBOTTOMMARGIN                        "Moon_PCL_Bottom_Margin"
#define DEFAULTMOONPCLBOTTOMMARGIN "1.0"
#define MOONPCLLINEHEIGHT                        "Moon_PCL_Line_Height"
#define DEFAULTMOONPCLLINEHEIGHT "0.222"
#define MOONPCLFIRSTPAGE                         "Moon_PCL_First_Page_No"
#define DEFAULTMOONPCLFIRSTPAGE  (size_t) 1

#define MOONPSCLMARGIN                           "Moon_Psc_Left_Margin"
#define DEFAULTMOONPSCLMARGIN "0.5"
#define MOONPSCRMARGIN                           "Moon_Psc_Right_Margin"
#define DEFAULTMOONPSCRMARGIN "0.5"
#define MOONPSCTOPMARGIN                           "Moon_Psc_Top_Margin"
#define DEFAULTMOONPSCTOPMARGIN "1.0"
#define MOONPSCBOTTOMMARGIN                        "Moon_Psc_Bottom_Margin"
#define DEFAULTMOONPSCBOTTOMMARGIN "0.83"
#define MOONPSCLINEHEIGHT                        "Moon_Psc_Line_Height"
#define DEFAULTMOONPSCLINEHEIGHT "0.352"
#define MOONPSCFIRSTPAGE                         "Moon_Psc_First_Page_No"
#define DEFAULTMOONPSCFIRSTPAGE  (size_t) 1

#define MOONHEADERTYPE                   "Moon_Header_Type"
#define DEFAULTMOONHEADERTYPE          4

#define MOONHEADERREFLECT                        "Moon_Anticipatory_Headings"
#define DEFAULTMOONHEADERREFLECT TRUE

#define MOONTRANSTABLE                   "Moon_Trans_Table"
#define DEFAULTMOONTRANSTABLE    "ITSMOON.TAB"

#define MOONTRANSGRADE                           "Moon_Trans_Grade"
#define DEFAULTMOONTRANSGRADE                  2

#define MOONPCLFCODE                             "Moon_PCL_Format_Codes"
#define DEFAULTMOONPCLFCODE              "ITMPCLFC.TAB"

#define MOONPSCFCODE                             "Moon_Psc_Format_Codes"
#define DEFAULTMOONPSCFCODE              "ITMPSCFC.TAB"

#define MOONPCLCWT                               "Moon_PCL_CWT"
#define DEFAULTMOONPCLCWT                        "ITMPCLCW.TAB"

#define MOONPSCCWT                               "Moon_Psc_CWT"
#define DEFAULTMOONPSCCWT                        "ITMPSCCW.TAB"

#define MOONLINENOS                              "Moon_Line_Numbers"
#define DEFAULTMOONLINENOS               FALSE

#define MOONPCLSTARTBANNER                               "Moon_PCL_Start_Banner"
#define DEFAULTMOONPCLSTARTBANNER        EMPTYDEFAULT80

#define MOONPSCSTARTBANNER                               "Moon_Psc_Start_Banner"
#define DEFAULTMOONPSCSTARTBANNER        EMPTYDEFAULT80

#define MOONPCLENDBANNER                         "Moon_PCL_End_Banner"
#define DEFAULTMOONPCLENDBANNER  EMPTYDEFAULT80

#define MOONPSCENDBANNER                         "Moon_Psc_End_Banner"
#define DEFAULTMOONPSCENDBANNER  EMPTYDEFAULT80

#define MOONPCLSTARTSEQ                          "Moon_PCL_Start_Sequence"
#define DEFAULTMOONPCLSTARTSEQ   EMPTYDEFAULT80

#define MOONPSCSTARTSEQ                          "Moon_Psc_Start_Sequence"
#define DEFAULTMOONPSCSTARTSEQ   EMPTYDEFAULT80

#define MOONPCLENDSEQ                                    "Moon_PCL_End_Sequence"
#define DEFAULTMOONPCLENDSEQ             EMPTYDEFAULT80

#define MOONPSCENDSEQ                                    "Moon_Psc_End_Sequence"
#define DEFAULTMOONPSCENDSEQ             EMPTYDEFAULT80

#define MOONPCLFONT                                    "Moon_PCL_Font"
#define DEFAULTMOONPCLFONT             EMPTYDEFAULT80

#define MOONPSCFONT                                    "Moon_Psc_Font"
#define DEFAULTMOONPSCFONT             "ITMOOPSC.HDR"

/* --------------------- END OF DEFINED CONSTANTS ------------------------- */


/* ------------------------ STRUCTURE TEMPLATES --------------------------- */
struct XrefEntry
{       char pardesc[MAXPARAMDESC];
	void *parloc;
	char partype;
	size_t parsize;
};


struct FileInfo
{       char Dir[FILENAMELENGTH];
	char Ext[EXTLENGTH];
	char Name[FILENAMELENGTH];
};


struct AutoFlags
{       boolean Required;
	boolean Brl;
	boolean BrlTrans;
	boolean BrlEmbForm;
#ifndef BRAILLE_IT
	    boolean BrlPCLForm;
    	boolean BrlPscForm;
        boolean Moon;
		boolean MoonTrans;
        boolean MoonPscForm;
        boolean MoonPCLForm;
#endif
    boolean ScreenOn;
};


struct SystemParams
{       char ParamName[FILENAMELENGTH];

    struct FileInfo Source;

    char EmbossName[FILENAMELENGTH];

    #if !defined(BRAILLE_IT)
    	char PageRange[ARRAY80LENGTH];
    	int Copies;

        boolean Network;
    	boolean Confirm;
    	boolean Pause;

        char PCLName[FILENAMELENGTH];
    	char PscName[FILENAMELENGTH];

	    char EmbossPort[PORTLENGTH];
	    char PCLPort[PORTLENGTH];
	    char PscPort[PORTLENGTH];
    #endif
};



struct Page
{       size_t Width;
    size_t Length;
    size_t FirstPage;
};

#if !defined(BRAILLE_IT)
struct P_Page
{       char LMargin[NUMBER_STRLEN];
    char RMargin[NUMBER_STRLEN];
    char TopMargin[NUMBER_STRLEN];
    char BottomMargin[NUMBER_STRLEN];
    char LineHeight[NUMBER_STRLEN];
    size_t FirstPage;
};
#endif



struct BrlParams
{       char ParamName[FILENAMELENGTH];
	boolean TransInit;

	struct FileInfo Trans;
    struct FileInfo EmbForm;

	int HeaderType;
	boolean HeaderReflect;

	int TransGrade;
	char TransTable[FILENAMELENGTH];
    char AcronymTable[FILENAMELENGTH];

    struct Page EmbPage;

	char EmbFormatCode[FILENAMELENGTH];
#if !defined(BRAILLE_IT)
	char EmbCWT[FILENAMELENGTH];
#endif
	char EmbReport[FILENAMELENGTH];

    #if !defined(BRAILLE_IT)
    	boolean LineNos;

    	char EmbStartBanner[FILENAMELENGTH];
    	char EmbEndBanner[FILENAMELENGTH];

    	char EmbStartSeq[FILENAMELENGTH];
        char EmbEndSeq[FILENAMELENGTH];
        struct FileInfo PCLForm;
        struct FileInfo PscForm;
    #endif

};
        
#ifndef BRAILLE_IT        
struct MoonParams
{   char ParamName[FILENAMELENGTH];
	boolean TransInit;

	struct FileInfo Trans;
	struct FileInfo PCLForm;
    struct FileInfo PscForm;

	int HeaderType;
	boolean HeaderReflect;

	int TransGrade;
	char TransTable[FILENAMELENGTH];

	boolean LineNos;

    char PscStartBanner[FILENAMELENGTH];
    char PscEndBanner[FILENAMELENGTH];

    char PscStartSeq[FILENAMELENGTH];
    char PscEndSeq[FILENAMELENGTH];
    char PscFontFile[FILENAMELENGTH];

    struct P_Page PscPage;

    char PscFormatCode[FILENAMELENGTH];
    char PscCWT[FILENAMELENGTH];
    char PscReport[FILENAMELENGTH];

    char PCLStartBanner[FILENAMELENGTH];
    char PCLEndBanner[FILENAMELENGTH];
    char PCLStartSeq[FILENAMELENGTH];
    char PCLEndSeq[FILENAMELENGTH];
    char PCLFontFile[FILENAMELENGTH];
    struct P_Page PCLPage;
    char PCLFormatCode[FILENAMELENGTH];
    char PCLCWT[FILENAMELENGTH];
    char PCLReport[FILENAMELENGTH];
};
#else
struct MoonParams
{	char IgnoreMe;
}; /* Empty if BRAILLE_IT defined.*/
#endif                  
                  
struct FilePath
{       char drv[DRIVELENGTH];
	char dir[FILENAMELENGTH];
	char name[NAMELENGTH];
	char ext[EXTLENGTH];
};

struct OutputSequence {
  char seq[MAXSEQUENCELENGTH];
  int  seqlength; /* Logical length of the associated sequence data*/};

struct PageRangeNode {
     unsigned int FirstPage;
     unsigned int LastPage;
     struct PageRangeNode *NextNode;
};

/* -------------------- END OF STRUCTURE TEMPLATES ------------------------ */


/* ------------------------------ UNIONS ---------------------------------- */
/* -------------------------- END OF UNIONS ------------------------------- */

/* ------------------------------ TYPES ----------------------------------- */
typedef enum { false, true } flag;
/* -------------------------- END OF TYPES -------------------------------- */


/* ----------------------- FUNCTION PROTOTYPES ---------------------------- */
int __cdecl main(int argc, char *argv[]);

#ifdef CSCAPEVER
int aboutsys(VOID *sdata, int idata);
int ExitFunc(VOID *sdata, int idata);
int Load_Config_Param(VOID *sdata, int idata);
int Save_Config_Param(VOID *sdata, int idata);
int Set_Config_FileMan(VOID *sdata, int idata);
int Set_Config_Operating(VOID *sdata, int idata);
int Set_Config_Output(VOID *sdata, int idata);
int SetupSystem(VOID *sdata, int idata);

int TranslateBrl(VOID *sdata, int idata);
int EmbFormatBrl(VOID *sdata, int idata);
int EmbTransFormatBrl(VOID *sdata, int idata);
int EmbOutputBrl(VOID *sdata, int idata);
int Load_Brl_Param(VOID *sdata, int idata);
int Save_Brl_Param(VOID *sdata, int idata);
int Set_Brl_FileMan(VOID *sdata, int idata);
int Set_Brl_TransOpt(VOID *sdata, int idata);
int Set_Brl_EmbPageForm(VOID *sdata, int idata);
int Set_Brl_EmbBanSeq(VOID *sdata, int idata);
int SetupBrl(VOID *sdata, int idata);

int TranslateMoon(VOID *sdata, int idata);
int PscFormatMoon(VOID *sdata, int idata);
int PscTransFormatMoon(VOID *sdata, int idata);
int PscOutputMoon(VOID *sdata, int idata);
int Load_Moon_Param(VOID *sdata, int idata);
int Save_Moon_Param(VOID *sdata, int idata);
int Set_Moon_FileMan(VOID *sdata, int idata);
int Set_Moon_TransOpt(VOID *sdata, int idata);
int Set_Moon_PscPageForm(VOID *sdata, int idata);
int Set_Moon_PscBanSeq(VOID *sdata, int idata);
int SetupMoon(VOID *sdata, int idata);

boolean spc_itsmenu(sed_type sed, int scancode);
boolean spc_setupmenu(sed_type sed, int scancode);
boolean spc_params(sed_type sed, int scancode);
#endif

int DecodeParameterFile(char *FName, struct XrefEntry *Xref, int MaxEntry);
/* -------------------- END OF FUNCTION PROTOTYPES ------------------------ */


/* ------------------------- GLOBAL DATA ---------------------------------- */
#ifdef CSCAPEVER
extern sfile_type lnffile;
extern sed_type background;
#endif

extern char errmsg[];
extern boolean abrt;

extern struct XrefEntry ConfigXref[];
extern struct XrefEntry BrlXref[];
#ifndef BRAILLE_IT
    extern struct XrefEntry MoonXref[];
#endif
extern struct SystemParams SysParam;
extern struct BrlParams BrlParam;
#ifndef BRAILLE_IT
	extern struct MoonParams MoonParam;
#endif
extern struct AutoFlags Auto;
extern struct FilePath prog;
extern struct FilePath current;
/* ---------------------- END OF GLOBAL DATA ------------------------------ */
