/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/* Start of ITSFUNC.H	 11/5/92 */
/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*1.3*19/04/93*ITSlite preprocessor commands "CSCAPEVER=1"       *30301*MW */
/***************************************************************************/
/*1.2*08/03/93*Definitions/Prototype added for Transform.	     *30301*MW */
/***************************************************************************/
/*1.1*19/05/92*Version Notes added.                              *30301*KJM*/
/***************************************************************************/
/*1.0*11/05/92*Creation Date.                                    *30301*MJH*/
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/* BRLEMBOP.C ITBEMBOP.C ITBFM.C ITBTRANS.C ITS.C ITSFUNC.C ITSMENU.C      */
/* TRANFILE.C		                                                   */
/*                                                                         */
/* ITBEMBFM.C ITBFERR.C ITFMEXEC.C ITMKPG.C ITRDBFRM.C ITRDCWT.C ITREPORT.C*/
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/

/* ------------------------- DEFINED CONSTANTS ---------------------------- */
#define VALID TRUE /* OK, ok so I could have just used TRUE and FALSE, */
#define INVALID FALSE /* but it doesn't take up any run-time processor time...*/

#define POPMSG_CLR 0x4F
#define POPPROMPT_CLR 0x4F
#define ERRORREG_CLR 0x4F
#define ERRORBACK_CLR 0x4F
#define ERRORHI_CLR 0x44
#define CONFIRMREG_CLR 0x4F
#define CONFIRMBACK_CLR 0x4F
#define CONFIRMHI_CLR 0x7F

#define SOURCEDESTERRMSG "Source and destination files cannot be same"
#define SOURCETRANSERRMSG "Source and translation files cannot be same"
#define SOURCETRANSDESTERRMSG "Source, trans. and destination files cannot be same"
#define TRANSDESTERRMSG "Translation and destination files cannot be same"
#define BOTHFILESERRMSG "Both source and destination files must be named"
#define ALLFILESERRMSG "Source, trans. and destination files must be named"
#define NOSOURCEERRMSG "Source file must be named"
#define BADSOURCEERRMSG "Source file does not exist"
#define PAGESERRMSG "Page range specification is incorrect"
#define NOERRMSG "\0"

#define TWIP 1440
/* --------------------- END OF DEFINED CONSTANTS ------------------------- */


/* ------------------------ STRUCTURE TEMPLATES --------------------------- */
/* -------------------- END OF STRUCTURE TEMPLATES ------------------------ */


/* ------------------------------ UNIONS ---------------------------------- */
/* -------------------------- END OF UNIONS ------------------------------- */


/* ----------------------- FUNCTION PROTOTYPES ---------------------------- */
void __cdecl ctrlchandler(int sig);
void ITS_Error(char *msg, char *module, int row, int col);
void ITS_Prompt(char *msg, int row, int col);
boolean Confirm(char *msg, int row, int col);
FILE *ITS_fopen (const char *filename, const char *mode);
int ITS_fclose (FILE *stream);
boolean LocateFile(char *Name);
char *trimstr(char *str);
char *charncpy(char *dest, const char *src, const size_t maxlen);
void movecursor(int row, int col);
void ProduceFullName(char *name, struct FileInfo finfo);
void StoreFullName(char *name, struct FileInfo *finfo);
size_t cv_fpstrtou(char *str);
int cv_fpstrtotwip(char *str);
#ifdef CSCAPEVER
int aux_cursor(sed_type sed, int msg, VOID *indata, VOID *outdata);
int aux_sourcetransdest(sed_type sed, int msg, VOID *indata, VOID *outdata);
int aux_sourcedest(sed_type sed, int msg, VOID *indata, VOID *outdata);
int aux_output(sed_type sed, int msg, VOID *indata, VOID *outdata);
#endif
/* -------------------- END OF FUNCTION PROTOTYPES ------------------------ */


/* ------------------------- GLOBAL DATA ---------------------------------- */
extern struct FileInfo SourceFinfo;
extern struct FileInfo TransFinfo;
extern struct FileInfo DestFinfo;
/* ---------------------- END OF GLOBAL DATA ------------------------------ */

/* End of ITSFUNC.H */
