/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/* Start of ITTRANS.H */
/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*1.3*01/06/92*Moon translation added.                           *30301*MJH*/
/***************************************************************************/
/*1.2*29/05/92*Standardised function naming & calling convention.*30301*MJH*/
/***************************************************************************/
/*1.1*18/05/92*Version Notes added.                              *30301*KJM*/
/***************************************************************************/
/*1.0*17/03/92*Creation Date.                                    *30301*MJH*/
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/* ITSMENU.C ITSAUTO.C ITTRANS.C BRLEMBOP.C                                */
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/

/* ------------------------- DEFINED CONSTANTS ---------------------------- */
/* --------------------- END OF DEFINED CONSTANTS ------------------------- */


/* ------------------------ STRUCTURE TEMPLATES --------------------------- */
/* -------------------- END OF STRUCTURE TEMPLATES ------------------------ */


/* ------------------------------ UNIONS ---------------------------------- */
/* -------------------------- END OF UNIONS ------------------------------- */


/* ----------------------- FUNCTION PROTOTYPES ---------------------------- */
boolean braille_translate(char *source, char *dest, char *TransTable,
            boolean *TransInit,
#if !defined(BRAILLE_IT)
            boolean *MoonInit,
#endif
            int grade, boolean ScreenOn
#if !defined(BRAILLE_IT)
            , boolean SysPause
#endif
    	);
boolean moon_translate(char *source, char *dest, char *Table,
			boolean *TransInit, boolean *BrlInit,
         int grade, boolean ScreenOn, boolean SysPause);
boolean ConfirmTrans(char *tempsource, char *tempdest,
		     struct FileInfo *Source, struct FileInfo *Dest,
		     int *TransGrade);
boolean ConfirmVitalTrans(char *tempsource, char *tempdest,
            struct FileInfo *Source, struct FileInfo *Dest
#if !defined(BRAILLE_IT)
            ,int *TransGrade, char *TransTable
#endif
    	);
int itinit (char *transtablename, char *acrotablename
#if defined(BRAILLE_IT)
  , char *source/*test220695*/
#endif
);
void itclose (void);
/* -------------------- END OF FUNCTION PROTOTYPES ------------------------ */


/* ------------------------- GLOBAL DATA ---------------------------------- */
extern struct FileInfo SourceFinfo;
extern struct FileInfo TransFinfo;
extern struct FileInfo DestFinfo;
/* ---------------------- END OF GLOBAL DATA ------------------------------ */

