/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/*test130695: Change prototype of itinit to include source file */
/***************************************************************************/
/*Ver*  Date  *                Version notes                     *Projt*INS*/
/***************************************************************************/
/***************************************************************************/
/* . *  /  /  *                                                  *     *   */
/***************************************************************************/
/*1.0*22/07/94*Creation Date.                                    *30414*NO */
/***************************************************************************/
/*This File is part of the following .C files:                             */
/*                                                                         */
/* TRANSLAT.C                                                              */
/*                                                                         */
/*Any change to this file means that the above programs have to be         */
/*recompiled with a new version number.                                    */
/***************************************************************************/
/*            TRANSLAT HEADER FILE                      	               */
#define		ALPHA 	200	/* DEFINES MAXIMUM NO. OF ENTRIES IN ALPHABET TABLE */
#define     NENTRY    1250   /* DEFINES MAXIMUM NO. OF ENTRIES IN CONTRACTION TABLE */
#define     NSV       15   /* DEFINES NO. OF STATE VARIABLES */
#define     NIC       35   /* DEFINES NO. OF INPUT CLASSES */
#define     NDTC       20   /* DEFINES NO. OF DECISION TABLE CONDITIONS */
#define     MAXRCC      5 /*Max right context classes */
#define     BUF_SIZE   10   /* Defines input buffer size */
#define     OUT_SIZE    20 /* Max output signs per table entry */
/* Block i/o */
#if !defined(BRAILLE_IT)
    #define BLK_BUFSIZE 2048
#else
    #define BLK_BUFSIZE 256
#endif

#define NOCRLF 0
#define CRLF 1
/* Translation mode manifest constants */
/*test280994#define     GRADE2      0 /* Normal mode - no state variable set */
#define     GRADE2      GRADE1+nsv /* Reset GRADE1 state variable */
#define     GRADE1      3 /* Index + 1of state variable set for grade 1 translation */
#define     ASCCODE     5 /* Index + 1 of state variable set for ASCII translation */
#define     ALTCODE     10 /* Index + 1 of state variable set for alternative code */
#define NOCONTRACT       8 /* Index + 1 of state variable set for temp. suppress. contracting */
#define	    DIGSTRFLD  23 /*Field in table file where digit string
			   is broken up at read-in to form int's */
#define     CURFUNC ittrans /* Useful when calling recursively */

#define SLASH '/'
#define BACKSLASH '\\'
#define FORMAT_START '$'
#define EOFCHAR 0x1A
#define ALTERNATE_LETTERSIGN '`'
/* defined constants for translat_flags */
#define CAPSENABLED		1
#define ALPHANUMSIGNENABLED	2
#define KEEPNEWLINES 0x1000
#define acrofl_name "acrosrce.tmp"


/*                               INTEGRATED TRANSLATOR EXTERNALS          */

#pragma pack(1)
struct alph {
  size_t extent;
  unsigned char  symbol;
  unsigned char  cclass;
  unsigned char  altsg;
  unsigned char  singsg;
  unsigned char  ascsg;
};

struct cont {
  unsigned char *ctable;
  unsigned char *tsign;
  int branch;
  unsigned char rcc;
  unsigned char iclass;
  unsigned char shifno;
};
#pragma pack()

/* Externals */
extern unsigned char inblok[], outblok[], *inblkptr, *endinblk;
extern inbuf_full;
extern unsigned char table_versno[];
extern size_t nsv;/*test280994*/

/*                        Function Prototypes                             */
/*                        -------------------                             */

    static void  __near translate_chr   (unsigned char __near *shiftstr,
		unsigned char *outstr, int *outlen);
    static void   __near search      (unsigned char __near *shiftstr,
			unsigned char *outstr);
    static void   __near test_match      (size_t index, size_t nxtlev,
                    size_t __near *pointr);
    static void   __near match       (size_t index, size_t pointr);
    static void   __near mismatch    (size_t __near *index, size_t pointr,
                    size_t __near *nxtlev);
    static void   __near check_IC    (size_t index);
    static void   __near accept      (unsigned char __near *shiftstr,
			unsigned char *outstr, size_t index, size_t pointr);
    static void   __near adjust_SV   (void);
    static void   __near no_cont     (unsigned char __near *shiftstr,
			unsigned char *outstr);
    static void   __near accept_newline    (unsigned char __near *instr, unsigned char *outstr);
    int     itinit          (char *transtablename, char *acrotablename
#if defined(BRAILLE_IT)
            , char *source
#endif
    );
    static int   __near shift       (int nch, unsigned char __near *str);
    static void   __near dlr_F       (unsigned char __near *shiftstr,
			unsigned char *outstr);
    unsigned char    *ittrans        (unsigned char *instr,
				 unsigned char *outstr,
                 int *len, unsigned mode);
    static void  __near read_format     (unsigned char *in, size_t strlength,
            unsigned char __near *shiftstr, unsigned char *outstr);
    static unsigned char * __near evebtranslat
                (unsigned char __near *format,
                unsigned char __near *instr, unsigned char *outstr,
				size_t transmode);
    static int        __near isalphanum    (unsigned char __near *str,
                      int *postcodeind);
    unsigned char * __near getstrbuf   (unsigned char *buf, FILE *rfileptr);
    unsigned char * __near putstrbuf   (unsigned char *buf, unsigned char *str,
		FILE *wfileptr, int crlfmode);
    unsigned char *getblok     (unsigned char *buf, FILE *rfileptr);
    unsigned char *putblok     (unsigned char *buf,
					FILE *wfileptr);
    void            __near blk_clrbuf          (unsigned char *buf, int length);
    void            itclose             (void);
