/* This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version. */

/* This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details. */

/* You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA 02111-1307, USA. */

/***************************************************************************
 * main module for converting text table file to binary.                  *
 * 12-Apr-1995                                                            *
/***************************************************************************/
/* Note: The INCLUDE environment variable must contain the path to the ITS */
/* system directory for this utility to compile.                           */
/***************************************************************************/

#include <stdio.h>
#include "tx2bintb.h"
#include "translat.h"
#include "trans.c"
#include "extra.c"
/* TXINIT.OBJ & BININIT.OBJ must be compiled with this program */
#pragma warning(once:4057)

boolean yorn(const char *question);     /*Proto- */
int writetobin(char *binfilename);      /*types  */
int txinit(char *table_txt);

int __cdecl main(int argc, char *argv[])
{
#if !defined(BRAILLE_IT)
  #error Preprocessor variable BRAILLE_IT must be defined .. Abandoned!
#endif
    char t_tablename[FILENAMELENGTH];
    char b_tablename[FILENAMELENGTH];
    char modulename[] = "main";

    if (argc < 3) {
        puts("Syntax: <text-table-name> <binary-table-name>\n");
        exit(1);
    }

/* Find location of this program by passing argv[0] to LocateFile */
    if (LocateFile(argv[0]) == FALSE)
        exit(2);

/* Find location of table file */
    strcpy(t_tablename, argv[1]);
    if (LocateFile(t_tablename) != TRUE)
        exit(1);
    /*test120795strcpy(b_tablename, argv[2]);*/
    if (_fullpath(b_tablename, argv[2], FILENAMELENGTH) == NULL) {/*test120795*/
        printf("\nError making path: %s", argv[2]);
        exit(2);
    }/*test120795*/

/* Can we create output file? */
    if (_stricmp(argv[1], argv[2]) == 0) { /* Not perfect, but ... */
        puts("\n\aBinary table must not overwrite the text table!");
        exit(1);
    }
    errno = 0;
    if (_access(b_tablename, 00) == 0 && !errno) { /* File already exists */
        if (yorn("File already exists.  Overwrite") == FALSE) {
            puts("\nok!");
            exit(1);
        }
        else
            puts("\n");
    }

/* Initialise */
    printf("Initialsing text table (%s)\n", t_tablename);
    if (txinit(t_tablename) == FALSE)
        exit(-1);
    printf("Writing binary table (%s)\n", b_tablename);
    if (writetobin(b_tablename) == ERROR)
        exit(-1);

    puts("");
    exit(0);
    return 0;
}

/***************************************************************************/
